unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, WPRich, WPRuler, WPTbar, WPStatus, Buttons, WPDEFS, WPTXTDEF,
  Menus, PrinPr, WPWordP, WPFinder, Wpstat2, Wpspdlg1, Wpwinctr;

type
  TForm1 = class(TForm)
    WPToolBar1: TWPToolBar;
    WPRuler1: TWPRuler;
    WPRichText1: TWPRichText;
    Image1: TImage;
    PopupMenu1: TPopupMenu;
    Centimeter1: TMenuItem;
    Inch1: TMenuItem;
    PageSize1: TMenuItem;
    WPRichText2: TWPRichText;
    WPSpellCheckDlg1: TWPSpellCheckDlg;
    WPAltStatusBar1: TWPAltStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure WPRichText1HyperLinkEvent(Sender: TObject; text,
      stamp: String; LineNumber: Longint);
    procedure WPStatusBar1Selection(Sender: TObject; index: Integer;
      typ: TWPStatusItemCont; name: String; x, y, w: Integer;
      var Button: TMouseButton; var Shift: TShiftState);
    procedure WPStatusBar1Update(Sender: TObject);
    procedure Centimeter1Click(Sender: TObject);
    procedure Inch1Click(Sender: TObject);
    procedure WPRichText1PrintFooter(Sender: TObject;
      prCanvas: TCanvas; x, y, w, h, PageNumber: Integer;
      LineNumber: Longint);
    procedure WPRichText1PrintHeader(Sender: TObject;
      prCanvas: TCanvas; x, y, w, h, PageNumber: Integer;
      LineNumber: Longint);
    procedure WPRichText1ShiftTabPressed(Sender: TObject);
    procedure WPRichText1CtrlTabPressed(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure WPRichText1StartSpellCheck(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private                                                                     
    { Private-Deklarationen }
  public

    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  p : TSpeedButton;
begin
   WPToolBar1.AddControl(Image1);
   { GetIcon: (index, group, number) }
   p := WPToolBar1.GetIcon(0,WPI_GR_PRINT,WPI_CO_PRINT);
   if p<>nil then
   begin  { Note: You may change everything except of OnClick and Tag!
            You may change OnClick too, if you call the ToolBar.Click procedure
            in your OnClick procedure }

          p.ShowHint := TRUE;
          p.Hint := 'Print Page';
   end;
end;

procedure TForm1.WPRichText1HyperLinkEvent(Sender: TObject; text,
  stamp: String; LineNumber: Longint);
var
  c : array[0..255] of Char;
begin
  StrPcopy(c,text);
  MessageBox(Handle,c,'Hyperlink clicked',0);
end;

procedure TForm1.WPStatusBar1Selection(Sender: TObject; index: Integer;
  typ: TWPStatusItemCont; name: String; x, y, w: Integer;
  var Button: TMouseButton; var Shift: TShiftState);
begin
  if typ=stUnit then
  begin
   if WPRuler1.Units = Centimeter then
      WPRuler1.Units := Inch else WPRuler1.Units:=Centimeter;
   if WPRuler1.Units = Centimeter then
     WPAltStatusBar1.SetString(stUnit,'Cent.')
   else WPAltStatusBar1.SetString(stUnit,'Inch');
  end else if Typ=stTxtFmt then
  begin
    if WPRichText1.MemoryFormat = fmRichText then
    begin  if MessageBox(Handle,'Discard text attributes?','MemoryFormat',
          MB_YESNO)=IDYES then  WPRichText1.MemoryFormat := fmPlainText;
    end
    else if MessageBox(Handle,'create text attributes?'+#10+
           'Need _much_ more memory then!','MemoryFormat',
          MB_YESNO)=IDYES then WPRichText1.MemoryFormat := fmRichText;
  end;
end;

procedure TForm1.WPStatusBar1Update(Sender: TObject);
begin
   if WPRuler1.Units = Centimeter then
     WPAltStatusBar1.SetString(stUnit,'Cent.')
   else WPAltStatusBar1.SetString(stUnit,'Inch');
end;

procedure TForm1.Centimeter1Click(Sender: TObject);
begin
   WPRuler1.Units := Centimeter;
   WPAltStatusBar1.SetString(stUnit,'Cent.');
end;

procedure TForm1.Inch1Click(Sender: TObject);
begin
   WPRuler1.Units := Inch;
   WPAltStatusBar1.SetString(stUnit,'Inch');
end;

procedure TForm1.WPRichText1PrintFooter(Sender: TObject;
  prCanvas: TCanvas; x, y, w, h, PageNumber: Integer; LineNumber: Longint);
begin
  prCanvas.Font.Name := 'Arial';
  prCanvas.Font.Size := 12;
  prCanvas.Pen.Color := clBlack;
  prCanvas.MoveTo(x,y);
  prCanvas.LineTo(x+w,y);
  prCanvas.TextOut(x+(w-prCanvas.TextWidth('-----'))div 2,
                   y+(h-prCanvas.TextHeight('A'))div 2,
                   '- '+ IntToStr(PageNumber)+' -');
end;

procedure TForm1.WPRichText1PrintHeader(Sender: TObject;
  prCanvas: TCanvas; x, y, w, h, PageNumber: Integer; LineNumber: Longint);
begin
  prCanvas.Font.Name := 'Arial';
  prCanvas.Font.Size := 14;
  prCanvas.Font.Color:= clBlue;
  prCanvas.TextOut(x+(w-prCanvas.TextWidth('Julian Ziersch Software'))div 2,
                   y+(h-prCanvas.TextHeight('A'))div 2,
                   'Julian Ziersch Software');
end;

{ You may use Shift TAB und Ctrl TAB to move the Focus.
  Shift TAB is called wenn pressing Ctrl + Shift TAB, too
   Shift TAB move Focus <----
   Ctrl TAB move focus ----> }
procedure TForm1.WPRichText1ShiftTabPressed(Sender: TObject);
begin
  MessageBox(Handle,'Shift + Tab','Key pressed :',0);
end;

procedure TForm1.WPRichText1CtrlTabPressed(Sender: TObject);
begin
  MessageBox(Handle,'Ctrl + Tab','Key pressed :',0);
end;

{ This will change the attributes of found text
  in the example it will put a hyperlink to all text
  following ftp:\\ to whitespace }
procedure TForm1.BitBtn1Click(Sender: TObject);  { uses WPFinder + WPWordP + WPDefs }
var
  a : TAttr;
  changed : Boolean;
begin
  with WPRichText1.Finder do
  begin
    EndChar := #32;
    WildCard := '*';
    fsWordProc := WPRichText1.WordBox;
    FHeader := WPRichText1.WText.aktive^.header;     
    first_par := WPRichText1.WText.aktive^.p;
    changed := FALSE;
    ToStart;
    while Next('ftp:\\*') do
    begin
      MoveFoundPos(Length('ftp:\\'));
      a := foundAttr;
      if afsHyperLink in a.style then        { Example switches ON/OFF }
             exclude(a.style, afsHyperLink)
      else   include(a.style, afsHyperLink); { or any other style }
      a.Size := 20;    { you may alter even the size ! }
      foundAttr := a;
      changed :=TRUE;
    end;                 
    if changed then
    begin
      WPRichText1.WordBox.ReformatAll(WPRichText1.WText.aktive^.p);  { only nessassry if Char Height / Width are changed }
      WPRichText1.WordBox.Reformat(nil);  { only nessassry if Char Height / Width are changed }
      WPRichText1.invalidate;
    end;
  end;   
end;

procedure TForm1.WPRichText1StartSpellCheck(Sender: TObject);
begin
   if Sender is TWPRichText then     
   begin
      WPSpellCheckDlg1.EditBox := (Sender as TWPRichText);
      WPSpellCheckDlg1.Execute;
   end;                               
end;

procedure TForm1.FormResize(Sender: TObject);
var
 y,h,w  : Integer;
begin
   y := WPRuler1.Top+WPRuler1.Height;
   h := Height - 50 - y;
   w := (Width div 2)-6;
   WPRichText1.Setbounds(2, y, w, h);
   WPRichText2.Setbounds(w +3,y,w, h);
end;

end.
